#ifndef CONNECT_APP_H
#define CONNECT_APP_H

#include <AppKit.h>
#include <InterfaceKit.h>
#include <SupportKit.h>
#include <StorageKit.h>
#include "View.h"


#define MENU_APP_NEW        'APnw'
#define MENU_GAME_EDIT      'APmd'
#define MENU_GAME_SAVE		'APsv'
#define MENU_GAME_DELETE    'APdl'
#define MENU_GAME_UNDO      'APud'
#define MENU_GAME_REDO      'APrd'
#define MENU_FIELD			'APfd'

#define MSG_SAVE		    'Save'

class Node {
public:
	BString name;
	BMessage *archive;
	Node(BString Name, BMessage *archive);
};

class FieldList {
	BList list;
public:
	~FieldList();
	BMessage *ItemAt(int32 i);
	void BuildMenu(BMenu *menu, int32 id);
	int32 Find(BString name);
	void Replace(int32 i, BMessage *archive);
	void Insert(BString name, BMessage *archive);
	void Remove(int32 i);
	void Save(BFile *file);
	void Restore(BFile *file);
};

class AppWindow : public BWindow {
public:
	BMenuBar *menubar;
	BMenu *field;
	View *view;
	FieldList fieldList;
	BPath appPath; 

	AppWindow(BRect);
	bool QuitRequested();
	void AboutRequested();	
	void MessageReceived(BMessage *message);
	
	void UpdateUnRedoMenu();
	
	void Save();
	void SavePreferences();
	void RestorePreferences();
};

class App : public BApplication {
public:
	AppWindow *window;
	App();
};

#define my_app ((App*)be_app)
#endif